#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string.h>
#include <vector>
#include <algorithm>
#include <iterator>
#include <array>
#include <string>
#include <sstream>


#include "common.h"
//log
#include <math.h>

using namespace std;

vector<vector<int> > chordless_cycles(Graph G) {
	//implementovane  z http://stackoverflow.com/questions/4022662/find-all-chordless-cycles-in-an-undirected-graph
	vector < vector<int> > cycles; //vsetky najdene bezstrunove cykly
	bool removed[G.n]; //Vrcholy z ktorych sme nasli vsetky cykly, a tak ich uz mozeme ignorovat
	for (int i = 0; i < G.n; i++)
		removed[i] = false;

	for (int i = 0; i < G.n; i++) {
		if(G.n>500 ){
			cout<<i<<endl;
		}
		Vertex firstV = G.vertices[i];
		//pre kazdy vrchol iterujeme pre dvojice susedov
		for (int j = 1; j < K; j++) {
			for (int k = 0; k < j; k++) {
				if (removed[firstV.neighbors[j]]
						|| removed[firstV.neighbors[k]])
					continue;
				vector<int> cyklus;
				cyklus.push_back(i);
				cyklus.push_back(firstV.neighbors[j]);
				if (adjacent(G.vertices[firstV.neighbors[j]],
						G.vertices[firstV.neighbors[k]])) {
					//cyklus dlzky 3
					cyklus.push_back(firstV.neighbors[k]);
					cycles.push_back(cyklus);
					continue;
				}
				vector < vector<int> > candidates;
				candidates.push_back(cyklus);

				while (!candidates.empty()) {
					vector<int> line = candidates.back();
					candidates.pop_back();
					Vertex currentV = G.vertices[line.back()];

					for (int x = 0; x < K; x++) {
						if (removed[currentV.neighbors[x]])
							continue;  //weve already found all cycles with x
						bool haschord = false;
						for (int q = 1; q < line.size() - 1; q++) {
							if (adjacent(G.vertices[line[q]],
									G.vertices[currentV.neighbors[x]]))
								haschord = true;
						}
						if (haschord)
							continue;
						//to prevent returning from second vertex (and 'cycles' like 1-2-1)
						if (firstV.number == currentV.neighbors[x]) {
							continue;
						}
						if (currentV.neighbors[x] != firstV.neighbors[j]
								&& currentV.neighbors[x] != firstV.neighbors[k]
								&& adjacent(G.vertices[currentV.neighbors[x]],
										firstV)) {
							//chceme len cykly obsahujuce firstV, firstV,neighbors[j] a firstV,neighbors[k]
							continue;
						}

						if (currentV.neighbors[x] == firstV.neighbors[k]) {
							//its a chordlesss cycle
							vector<int> newcycle = line;
							newcycle.push_back(currentV.neighbors[x]);

							cycles.push_back(newcycle);
							continue;
						}

						vector<int> newline = line;
						if (newline.size() > 4 * log2(G.n + 1)) {
							continue;
						}
						newline.push_back(currentV.neighbors[x]);
						candidates.push_back(newline);
					}

				}
			}
		}

		removed[i] = true;
	}
	return cycles;
}

int main() { /*zatial pracuje len s kubickymi grafmi,
 ale to je len kvoli graphparseru, nie kvoli samotnemu algoritmu*/


	string filename;
	cout
			<< "sposob parsovania (1 pre Ba format, 2 pre zoznam hran, 3 pre Ba s cislom grafu"
			<< endl;
	int parsetype;
	cin >> parsetype;
	cout << "nazov suboru" << endl;
	cin >> filename;
	// filename="test6.txt";
	ifstream file(filename);

	string line;

	if (file.good()) {
		cout << "subor najdeny" << endl;
	} else {
		cout << "subor nenajdeny " << endl;
	}
	while (getline(file, line)) {
		if (line.at(0) == '{' || line.at(0) == ' ')
			continue;
		if (N < 1) {
			N = stoi(line);
		}

		for (int cisloGrafu = 0; cisloGrafu < N; cisloGrafu++) {	


			Graph G;
			switch (parsetype) {
			case 1:
				G = graphParser(file);
				break;
			case 2:
				G = graphParser2(file);
				break;
			case 3:
				G = graphParser3(file);
				break;
			}

			G.girth = Girth(G);
			cout <<endl<< "graph # " << cisloGrafu + 1 << endl;
			cout << endl << "girth:  " << G.girth << endl;
			if (G.girth > G.n / 2) {
				cout << "Graph has no cyclic edge cut";
				continue;
			}
			vector < vector<int> > chordless = chordless_cycles(G);
			//pre každé 2 beztetivové cykly, spusť ford-fulkerson
			G.connectivity = G.girth;
			cout << "# of chordless cycles" << chordless.size()
					<< endl;
			set < Part > parts;
			for (int a = 1; a < chordless.size(); a++) {

				
				for (int b = 0; b < a; b++) {
					//first lets check if the 2 cycles are disjunct  
					bool disjunct = true;
					for (int i = 0; i < chordless[a].size(); i++) {
						for (int y = 0; y < chordless[b].size(); y++) {
							if (chordless[a][i] == chordless[b][y]) {
								disjunct = false;
								break;
							}
						}
						if (!disjunct)
							break;
					}
					if (!disjunct)
						continue;

					//lets add 2 vertices, one for each cycle, connected to every vertex of that cycle
					Vertex sourceV;
					sourceV.number = G.n;
					sourceV.neighbors = (int*) malloc(
							(chordless[a].size()) * sizeof(int));
					sourceV.flow = (int*) malloc(
							(chordless[a].size()) * sizeof(int));
					sourceV.val = chordless[a].size();
					for (int i = 0; i < chordless[a].size(); i++) {
						sourceV.neighbors[i] = chordless[a][i];
					}
					Vertex drainV;

					drainV.number = G.n + 1;
					drainV.neighbors = (int*) malloc(
							chordless[b].size() * sizeof(int));
					drainV.flow = (int*) malloc(
							chordless[b].size() * sizeof(int));
					drainV.val = chordless[b].size();
					for (int i = 0; i < chordless[b].size(); i++) {
						drainV.neighbors[i] = chordless[b][i];
					}
					/*	cout << "running ford-fulk for:" << endl;
					 writecycle (chordless[a]);
					 writecycle(chordless[b]);*/
					int lastCon = G.connectivity;

					Result R = ford_fulkerson(G, sourceV, drainV);
					if (lastCon > R.maxflow) {
						G.connectivity = R.maxflow;
						parts.clear();
					}
					if (R.maxflow < G.girth && R.maxflow <= G.connectivity) {
						parts.insert(R.P1);
						parts.insert(R.P2);
						
					}
					destroyVertex(sourceV);
					destroyVertex(drainV);
				}
			}
			cout << "cc: " << G.connectivity << endl;
						if (parts.size() > 0) {
							vector < vector<int> > cuts;

							vector < Part > tmp(parts.begin(), parts.end());
							vector < vector<int> > partsVec;
							for (int i = 0; i < tmp.size(); i++) {
								partsVec.push_back(tmp[i].vertices);
								cuts.push_back(tmp[i].cut);
							}

							vector<int> atoms;
							atoms = getAtoms(partsVec, G.n);
							vector < vector<int> > coAtomsList;
							//coatoms[i] is the vector of all coatoms of atom i
							for (int i = 0; i < atoms.size(); i++) {
								coAtomsList.push_back(
										getCoAtoms(G,  partsVec[atoms[i]]));
							}
							int outofatom = G.n;
							bool inatom[G.n];
							for (int i = 0; i < G.n; i++)
								inatom[i] = false;

							cout << "# of atoms: " << atoms.size() << endl << endl;
							for (int i = 0; i < atoms.size(); i++) {
								cout << "atom " << i + 1 
										<< ", order: " << partsVec[atoms[i]].size() << endl;
								writecycle (partsVec[atoms[i]]);
								for (int ii = 0; ii < partsVec[atoms[i]].size(); ii++) {
									if (!inatom[partsVec[atoms[i]][ii]]) {
										outofatom--;
										inatom[partsVec[atoms[i]][ii]] = true;
									}
								}
								cout << "cut : " << endl;
								for (int ii = 0; ii < cuts[atoms[i]].size(); ii += 2) {
									cout << "[" << cuts[atoms[i]][ii] << ","
											<< cuts[atoms[i]][ii + 1] << "] ";
								}
								cout << endl;
								if (!coAtomsList[i].empty()) {
									cout << "atom has " << coAtomsList[i].size() / 2
											<< " co-atoms" << endl;
									for (int a = 0; a < coAtomsList[i].size(); a += 2) {
										cout << "  pair of vertices in coatom " << a / 2
												<< ": " << coAtomsList[i][a] << ", "
												<< coAtomsList[i][a + 1] << endl;
									}

								}
								cout
										<< "----------------------------------------------------------"
										<< endl;
								;

							}

							cout << "# of vertices not in atoms: " << outofatom << endl;
							for (int i = 0; i < G.n; i++) {
								if (!inatom[i])
									cout << i << " ";
							}
							cout << endl;
						}
						if (cisloGrafu != N - 1) {
							cout
									<< "=========================================================="
									<< endl;

						}
						destroyGraph(G);

		}
	}


	return 0;
}
